//
//  SettingSliderCell.m
//  scummvm
//
//  Created by Ilya Levin on 19/10/2015.
//
//

#import "SettingSliderCell.h"
#import "UIFont+ScummVMAdditions.h"
//#import "UIColor+MTAdditions.h"
#import "UILabel+MTAdditions.h"

using namespace std;
#import <string>
#import "NSStringAdditions.h"

NSString* const kSettingSliderCellIdentifier = @"SettingSliderCellIdentifier";

@interface SettingSliderCell ()
@property (retain, nonatomic) IBOutlet UISlider *slider;
@property (retain, nonatomic) IBOutlet UILabel *lblTitle;

@property (nonatomic) const Enhanced::SliderSetting* sliderSetting;
@end

@implementation SettingSliderCell

-(void)awakeFromNib
{
    [super awakeFromNib];
    
    [self.lblTitle configureWithTheme];
    
    [self.slider setThumbImage:[UIImage imageNamed:@"seekbar_thumb"] forState:UIControlStateNormal];
    [self.slider setThumbImage:[UIImage imageNamed:@"seekbar_thumb_disable"] forState:UIControlStateDisabled];
    [self.slider setMaximumTrackImage:[UIImage imageNamed:@"seekbar_base.9"] forState:UIControlStateNormal];
    [self.slider setMinimumTrackImage:[UIImage imageNamed:@"seekbar_fill.9"] forState:UIControlStateNormal];

}

-(void)configureWithSliderSetting:(const Enhanced::SliderSetting *)sliderSetting
{
    self.sliderSetting = sliderSetting;
    
    if (self.nativeUIInterface->hasFontwithLowercase()){
        self.lblTitle.text = [NSString stringWithCPPWString:sliderSetting->getTitle()];
    }
    else{ // Forcing capital letters if needed
        [_lblTitle setText:[[NSString stringWithCPPWString:sliderSetting->getTitle()] uppercaseString]];
    }

    int min = sliderSetting->getMinValue();
    int max = sliderSetting->getMaxValue();
    int cur = sliderSetting->getIntValue();
    
    self.slider.minimumValue = min;
    self.slider.maximumValue = max;
    self.slider.value = cur;
    
    self.slider.enabled = self.sliderSetting->getEnabledStates()[0] == true ? YES:NO;
    self.lblTitle.alpha = self.sliderSetting->getEnabledStates()[0] == true ? 1:0.6;
}

- (IBAction)sliderValueChanged:(id)sender
{
    self.sliderSetting->setIntValue((int)self.slider.value);
}


@end
