//
//  UIButton+MTAdditions.m
//  scummvm
//
//  Created by Ilya Levin on 29/10/2015.
//
//

#import "UIButton+MTAdditions.h"
#import "UIFont+ScummVMAdditions.h"
#import "UIColor+MTAdditions.h"
#import "GameInfo.h"

@implementation UIButton (MTAdditions)

-(void)configureWithTheme
{
    [self configureWithTheme:NO];
}

-(void)configureWithTheme:(BOOL)isPopupStyle
{
    if (CURRENT_GAME_TYPE == GAME_TYPE_FOTAQ) {
        
        if (!isPopupStyle)
        {
            BOOL isIpad = [UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPad;
            
            [self setBackgroundImage:[UIImage imageNamed:@"fotaq_button"] forState:UIControlStateNormal];
            [self setBackgroundImage:[UIImage imageNamed:@"fotaq_buttondisable"] forState:UIControlStateDisabled];
            [self.superview addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"V:[button(height)]" options:0 metrics:@{@"height":isIpad?@50:@30} views:@{@"button":self}]];
            [self.superview addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:[button(width)]" options:0 metrics:@{@"width":isIpad?@250:@135} views:@{@"button":self}]];
            
            self.adjustsImageWhenHighlighted = NO;
            self.adjustsImageWhenDisabled = NO;
        }
        self.titleLabel.textAlignment = NSTextAlignmentCenter;
        
        [self setContentHorizontalAlignment:UIControlContentHorizontalAlignmentCenter];

    }
    
    if (CURRENT_GAME_TYPE == GAME_TYPE_SIMON1) {
        
        if (!isPopupStyle)
        {
            BOOL isIpad = [UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPad;
            
            [self setBackgroundImage:[UIImage imageNamed:@"simon1_button"] forState:UIControlStateNormal];
            [self setBackgroundImage:[UIImage imageNamed:@"simon1_buttondisable"] forState:UIControlStateDisabled];
            [self.superview addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"V:[button(height)]" options:0 metrics:@{@"height":isIpad?@50:@30} views:@{@"button":self}]];
            [self.superview addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:[button(width)]" options:0 metrics:@{@"width":isIpad?@250:@135} views:@{@"button":self}]];
            
            self.adjustsImageWhenHighlighted = NO;
            self.adjustsImageWhenDisabled = NO;
        }
        self.titleLabel.textAlignment = NSTextAlignmentCenter;
        
        [self setContentHorizontalAlignment:UIControlContentHorizontalAlignmentCenter];
        
    }
    
    self.layer.masksToBounds = YES;
    self.titleLabel.clipsToBounds = NO;
    self.titleLabel.font = [UIFont mt_themeFontOfAppropriateSize];
    
    [self setTitleColor:[UIColor mt_mainButtonColor] forState:UIControlStateNormal];
    [self setTitleColor:[UIColor mt_selectedButtonColor] forState:UIControlStateHighlighted];
    [self setTitleColor:[UIColor mt_disabledButtonColor] forState:UIControlStateDisabled];
    [self setTitleShadowColor:[UIColor mt_mainshadowButtonColor] forState:UIControlStateNormal];
    [self setTitleShadowColor:[UIColor mt_selectedshadowButtonColor] forState:UIControlStateHighlighted];
    [self setTitleShadowColor:[UIColor mt_disabledshadowButtonColor] forState:UIControlStateDisabled];
    
    switch (CURRENT_GAME_TYPE) {
        case GAME_TYPE_IHNM:
            self.titleLabel.shadowOffset = CGSizeMake(1.0f, 1.0f);
            break;
            
        case GAME_TYPE_FOTAQ:
            self.titleLabel.shadowOffset = CGSizeMake(1.0f, 2.0f);
            break;
            
        case GAME_TYPE_SIMON1:
            self.titleLabel.shadowOffset = CGSizeMake(1.0f, 1.0f);
            break;
            
        case GAME_TYPE_SIMON2:
            self.titleLabel.shadowOffset = CGSizeMake(1.0f, 1.0f);
            break;
            
        case GAME_TYPE_T7G:
            self.titleLabel.shadowOffset = CGSizeMake(1.0f, 1.0f);
            break;
    }
}

@end
