//
//  UIColor+MTAdditions.m
//  scummvm
//
//  Created by Ilya Levin on 27/10/2015.
//
//

#import "UIColor+MTAdditions.h"
#import "UIColor+HexString.h"
#import "GameInfo.h"

@implementation UIColor (MTAdditions)

+(instancetype)mt_mainButtonColor
{
    switch (CURRENT_GAME_TYPE) {
        case GAME_TYPE_IHNM:
            return [UIColor colorWithPatternImage:[[UIImage imageNamed:@"Font_texture"] resizableImageWithCapInsets:UIEdgeInsetsZero resizingMode:UIImageResizingModeStretch]];
            break;
            
        case GAME_TYPE_FOTAQ:
            return [UIColor colorWithPatternImage:[[UIImage imageNamed:@"Font_texture"] resizableImageWithCapInsets:UIEdgeInsetsZero resizingMode:UIImageResizingModeStretch]];
            break;
            
        case GAME_TYPE_SIMON1:
            return [UIColor colorWithHexString:@"#463214"];
            break;
            
        case GAME_TYPE_SIMON2:
            return [UIColor colorWithHexString:@"#f2d6ae"];
            break;
            
        case GAME_TYPE_T7G:
            return [UIColor colorWithHexString:@"#d22c1507"];
            break;
            
    }
    
    return [UIColor colorWithPatternImage:[[UIImage imageNamed:@"Font_texture"] resizableImageWithCapInsets:UIEdgeInsetsZero resizingMode:UIImageResizingModeStretch]]; // default
}

+(instancetype)mt_mainshadowButtonColor
{
    switch (CURRENT_GAME_TYPE) {
        case GAME_TYPE_IHNM:
            return [UIColor blackColor];
            break;
            
        case GAME_TYPE_FOTAQ:
            return [UIColor blackColor];
            break;
            
        case GAME_TYPE_SIMON1:
            return [UIColor clearColor];
            break;
            
        case GAME_TYPE_SIMON2:
            return [UIColor colorWithHexString:@"#00000000"];
            break;
            
        case GAME_TYPE_T7G:
            return [UIColor colorWithHexString:@"#80ffd6b2"];
            break;
            
    }
    
    return [UIColor blackColor]; // default
}

+(instancetype)mt_selectedButtonColor
{
    switch (CURRENT_GAME_TYPE) {
        case GAME_TYPE_IHNM:
            return nil;
            break;
            
        case GAME_TYPE_FOTAQ:
            return [UIColor colorWithPatternImage:[UIImage imageNamed:@"Font_texture_selected"]];
            break;
            
        case GAME_TYPE_SIMON1:
            return [UIColor colorWithHexString:@"#65160d"];
            break;
            
        case GAME_TYPE_SIMON2:
            return [UIColor colorWithHexString:@"#fcead3"];
            break;
            
        case GAME_TYPE_T7G:
            return [UIColor colorWithHexString:@"#ff65160d"];
            break;
            
    }
    
    return [UIColor colorWithPatternImage:[UIImage imageNamed:@"Font_texture_selected"]]; // default
}

+(instancetype)mt_selectedshadowButtonColor
{
    switch (CURRENT_GAME_TYPE) {
        case GAME_TYPE_IHNM:
            return [UIColor blackColor];
            break;
            
        case GAME_TYPE_FOTAQ:
            return [UIColor blackColor];
            break;
            
        case GAME_TYPE_SIMON1:
            return [UIColor clearColor];
            break;
            
        case GAME_TYPE_SIMON2:
            return [UIColor blackColor];
            break;
            
        case GAME_TYPE_T7G:
            return [UIColor colorWithHexString:@"#a6fbd4b1"];
            break;
            
    }
    
    return [UIColor blackColor]; // default
}

+(instancetype)mt_disabledButtonColor
{
    switch (CURRENT_GAME_TYPE) {
        case GAME_TYPE_IHNM:
            return [UIColor colorWithPatternImage:[UIImage imageNamed:@"Font_texture_disabled"]];
            break;
            
        case GAME_TYPE_FOTAQ:
            return [[UIColor blackColor] colorWithAlphaComponent:0.52f];
            break;
            
        case GAME_TYPE_SIMON1:
            return [UIColor colorWithHexString:@"#80000000"];
            break;
            
        case GAME_TYPE_SIMON2:
            return [UIColor colorWithHexString:@"#f2d6ae"];
            break;
            
        case GAME_TYPE_T7G:
            return [UIColor colorWithHexString:@"#80000000"];
            break;
            
    }
    
    return [[UIColor blackColor] colorWithAlphaComponent:0.52f]; // default
}

+(instancetype)mt_disabledshadowButtonColor
{
    switch (CURRENT_GAME_TYPE) {
        case GAME_TYPE_IHNM:
            return [UIColor clearColor]; // remove shadow
            break;
            
        case GAME_TYPE_FOTAQ:
            return [UIColor clearColor]; // remove shadow
            break;
            
        case GAME_TYPE_SIMON1:
            return [UIColor clearColor]; // remove shadow
            break;
            
        case GAME_TYPE_SIMON2:
            return [UIColor clearColor]; // remove shadow
            break;
            
        case GAME_TYPE_T7G:
            return [UIColor colorWithHexString:@"#33fbd4b1"];
            break;
            
    }
    
    return [UIColor clearColor]; // default
}

@end
