//
//  UIFont+ScummVMAdditions.m
//  scummvm
//
//  Created by Ilya Levin on 27/10/2015.
//
//

#import "UIFont+ScummVMAdditions.h"
#import "GameInfo.h"
#import "UIStoryboard+scummVMAdditions.h"

@implementation UIFont (ScummVMAdditions)


+(instancetype)mt_defaultFontOfAppropriateSize
{
    BOOL ipad = [UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPad;
    return [self systemFontOfSize:ipad?30.0f:14.0f];
}

+(instancetype)mt_themeFontOfAppropriateSize
{
    if (CURRENT_GAME_TYPE == GAME_TYPE_IHNM){
        return [self mt_digitalFontOfAppropriateSize];
    }
    else if (CURRENT_GAME_TYPE == GAME_TYPE_FOTAQ) {
        return [self mt_adventureFontOfAppropriateSize];
    }
    else if (CURRENT_GAME_TYPE == GAME_TYPE_SIMON1 || CURRENT_GAME_TYPE == GAME_TYPE_SIMON2) {
        return [self mt_scarecrowFontOfAppropriateSize];
    }
    else if (CURRENT_GAME_TYPE == GAME_TYPE_T7G) {
        return [self mt_arabianFontOfAppropriateSize];
    }
    
    return [self mt_defaultFontOfAppropriateSize]; // default font
}

+(instancetype)mt_themeFontOfSize:(CGFloat)size
{
    if (CURRENT_GAME_TYPE == GAME_TYPE_IHNM){
        return [self mt_digitalFontOfSize:size];
    }
    else if (CURRENT_GAME_TYPE == GAME_TYPE_FOTAQ) {
        return [self mt_adventureFontOfSize:size];
    }
    else if (CURRENT_GAME_TYPE == GAME_TYPE_SIMON1 || CURRENT_GAME_TYPE == GAME_TYPE_SIMON2) {
        return [self mt_scarecrowFontOfSize:size];
    }
    else if (CURRENT_GAME_TYPE == GAME_TYPE_T7G) {
        return [self mt_arabianFontOfSize:size];
    }
    
    return [self systemFontOfSize:size]; // default font
}

+(instancetype)mt_digitalFontOfAppropriateSize
{
    BOOL ipad = [UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPad;
    return [self mt_digitalFontOfSize:ipad?40.0f:22.0f*[UIStoryboard relativeScale]];
}

+(instancetype)mt_digitalFontOfSize:(CGFloat)size
{
    UIFont* font = [UIFont fontWithName:@"01Digitall" size:size];
    
    return font;
}

+(instancetype)mt_adventureFontOfAppropriateSize
{
    BOOL ipad = [UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPad;
    return [self mt_adventureFontOfSize:ipad?30.0f:14.0f*[UIStoryboard relativeScale]];
}

+(instancetype)mt_adventureFontOfSize:(CGFloat)size
{
    UIFont* font = [UIFont fontWithName:@"Adventure" size:size];
    
    return font;
}

+(instancetype)mt_scarecrowFontOfAppropriateSize
{
    BOOL ipad = [UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPad;
    return [self mt_scarecrowFontOfSize:ipad?30.0f:14.0f*[UIStoryboard relativeScale]];
}

+(instancetype)mt_scarecrowFontOfSize:(CGFloat)size
{
    UIFont* font = [UIFont fontWithName:@"Oz's Wizard" size:size];
    
    return font;
}

+(instancetype)mt_arabianFontOfAppropriateSize
{
    BOOL ipad = [UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPad;
    return [self mt_arabianFontOfSize:ipad?30.0f:14.0f*[UIStoryboard relativeScale]];
}

+(instancetype)mt_arabianFontOfSize:(CGFloat)size
{
    UIFont* font = [UIFont fontWithName:@"Arabia" size:size];
    
    return font;
}

@end
