/*
 * TextureAllocator.h
 *
 *  Created on: Feb 3, 2013
 *      Author: omergilad
 */

#ifndef TextureAllocator_H_
#define TextureAllocator_H_

#include "OverlayBitmap.h"

#define GL_TEXTURE_WIDTH 1024
#define GL_TEXTURE_HEIGHT 1024
#define GL_TEXTURE_GRID_SIZE 64

#define GL_DYNAMIC_TEXTURE_WIDTH 128
#define GL_DYNAMIC_TEXTURE_HEIGHT 128

namespace Enhanced {


class TextureAllocator {
public:
	TextureAllocator();
	virtual ~TextureAllocator();

	void allocateBitmapInGlTexture(OverlayBitmap* bitmap);

private:

	bool attemptToAllocateSpaceInGrid(uint16 x, uint16 y, uint16 w, uint16 h);

	bool mAllocationGrid[GL_TEXTURE_WIDTH / GL_TEXTURE_GRID_SIZE]
	                     [GL_TEXTURE_HEIGHT * GL_TEXTURE_GRID_SIZE];
	uint16 mGridW;
	uint16 mGridH;

};

}

#endif /* TextureAllocator_H_ */
